%global debug_package %{nil}
%global package_name openshift-pipelines-client
%global product_name OpenShift Pipelines
%global golang_version 1.16
%global tkn_version 0.24.1
%global tkn_pac_version 0.10.1
%global tkn_commit d4eab3f3ea1ec647e0450e3e45de8a41140e119f
%global tkn_pac_commit d1fe4c50f4c21a64d5344c7b39ada9b684d4075b
%global build_hash %(c=%{tkn_commit}; echo ${c:0:7})
%global tkn_cli_version v%{tkn_version}
%global repo github.com/openshift/tektoncd-cli
%global source_dir tektoncd-cli-%{tkn_commit}
%global source_dir_pac pipelines-as-code-%{tkn_pac_commit}
%global source_tar tektoncd-cli-d4eab3f3ea1ec647e0450e3e45de8a41140e119f.tar.gz
%global source_pac_tar pipelines-as-code-d1fe4c50f4c21a64d5344c7b39ada9b684d4075b.tar.gz
%global spec_version 0.20.2

# spec_release_prefix is needed for legacy reasons; this was added back in the
# day as a hacky fix but now cannot be removed since the newer builds cannot
# contain an NVR lower than the older releases.
%global spec_release_prefix 1
%global spec_release %{spec_release_prefix}722

Name:           %{package_name}
Version:        %{tkn_version}
Release:        %{spec_release}%{?dist}
Summary:        A command line tool to enhance users productivity for working with %{product_name}
License:        ASL 2.0
URL:            https://%{repo}

Source0:        %{source_tar}
Source1:        %{source_pac_tar}
BuildRequires:  golang >= %{golang_version}
Provides:       %{package_name}
Obsoletes:      %{package_name} < %{tkn_version}

%description
The OpenShift Pipelines client is a CLI tool to work effectively with OpenShift pipelines

%prep
%setup -q -n %{source_dir}
%setup -c -n %{source_dir_pac} -a 1

%build
cd %{source_dir}
export CGO_ENABLED=0
GOOS=linux GOARCH=amd64 go build -mod=vendor \
           -ldflags "-X github.com/tektoncd/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/tektoncd/cli/pkg/cmd/version.clientVersion=%{tkn_version}" \
           -v -o ./bin/tkn-linux-amd64 ./cmd/tkn
GOOS=linux GOARCH=s390x go build -mod=vendor \
           -ldflags "-X github.com/tektoncd/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/tektoncd/cli/pkg/cmd/version.clientVersion=%{tkn_version}" \
           -v -o ./bin/tkn-linux-s390x ./cmd/tkn
GOOS=linux GOARCH=ppc64le go build -mod=vendor \
           -ldflags "-X github.com/tektoncd/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/tektoncd/cli/pkg/cmd/version.clientVersion=%{tkn_version}" \
           -v -o ./bin/tkn-linux-ppc64le ./cmd/tkn
GOOS=linux GOARCH=arm64 go build -mod=vendor \
           -ldflags "-X github.com/tektoncd/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/tektoncd/cli/pkg/cmd/version.clientVersion=%{tkn_version}" \
           -v -o ./bin/tkn-linux-arm64 ./cmd/tkn
GOOS=windows GOARCH=amd64 go build -mod=vendor \
           -ldflags "-X github.com/tektoncd/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/tektoncd/cli/pkg/cmd/version.clientVersion=%{tkn_version}" \
           -v -o ./bin/tkn-windows-amd64 ./cmd/tkn
GOOS=windows GOARCH=arm64 go build -mod=vendor \
           -ldflags "-X github.com/tektoncd/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/tektoncd/cli/pkg/cmd/version.clientVersion=%{tkn_version}" \
           -v -o ./bin/tkn-windows-arm64 ./cmd/tkn
GOOS=darwin GOARCH=amd64 go build -mod=vendor \
           -ldflags "-X github.com/tektoncd/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/tektoncd/cli/pkg/cmd/version.clientVersion=%{tkn_version}" \
           -v -o ./bin/tkn-darwin-amd64 ./cmd/tkn
GOOS=darwin GOARCH=arm64 go build -mod=vendor \
           -ldflags "-X github.com/tektoncd/cli/pkg/cmd/version.skipCheckFlag=true -X github.com/tektoncd/cli/pkg/cmd/version.clientVersion=%{tkn_version}" \
           -v -o ./bin/tkn-darwin-arm64 ./cmd/tkn
cd ..
cd %{source_dir_pac}
GOOS=linux GOARCH=amd64 go build -mod=vendor \
           -ldflags "-X github.com/openshift-pipelines/pipelines-as-code/pkg/params/version.Version=%{tkn_pac_version}" \
           -v -o ./bin/tkn-pac-linux-amd64 ./cmd/tkn-pac
GOOS=linux GOARCH=s390x go build -mod=vendor \
           -ldflags "-X github.com/openshift-pipelines/pipelines-as-code/pkg/params/version.Version=%{tkn_pac_version}" \
           -v -o ./bin/tkn-pac-linux-s390x ./cmd/tkn-pac
GOOS=linux GOARCH=ppc64le go build -mod=vendor \
           -ldflags "-X github.com/openshift-pipelines/pipelines-as-code/pkg/params/version.Version=%{tkn_pac_version}" \
           -v -o ./bin/tkn-pac-linux-ppc64le ./cmd/tkn-pac
GOOS=linux GOARCH=arm64 go build -mod=vendor \
           -ldflags "-X github.com/openshift-pipelines/pipelines-as-code/pkg/params/version.Version=%{tkn_pac_version}" \
           -v -o ./bin/tkn-pac-linux-arm64 ./cmd/tkn-pac
GOOS=windows GOARCH=amd64 go build -mod=vendor \
           -ldflags "-X github.com/openshift-pipelines/pipelines-as-code/pkg/params/version.Version=%{tkn_pac_version}" \
           -v -o ./bin/tkn-pac-windows-amd64 ./cmd/tkn-pac
GOOS=windows GOARCH=arm64 go build -mod=vendor \
           -ldflags "-X github.com/openshift-pipelines/pipelines-as-code/pkg/params/version.Version=%{tkn_pac_version}" \
           -v -o ./bin/tkn-pac-windows-arm64 ./cmd/tkn-pac
GOOS=darwin GOARCH=amd64 go build -mod=vendor \
           -ldflags "-X github.com/openshift-pipelines/pipelines-as-code/pkg/params/version.Version=%{tkn_pac_version}" \
           -v -o ./bin/tkn-pac-darwin-amd64 ./cmd/tkn-pac
GOOS=darwin GOARCH=arm64 go build -mod=vendor \
           -ldflags "-X github.com/openshift-pipelines/pipelines-as-code/pkg/params/version.Version=%{tkn_pac_version}" \
           -v -o ./bin/tkn-pac-darwin-arm64 ./cmd/tkn-pac
cd ..

%install
# tkn
cd %{source_dir}
mkdir -p %{buildroot}/%{_bindir}
%ifarch x86_64
install -D -m 0755 bin/tkn-linux-amd64 %{buildroot}%{_bindir}/tkn

install -d %{buildroot}%{_datadir}/bash-completion/completions
%{buildroot}%{_bindir}/tkn completion bash > %{buildroot}%{_datadir}/bash-completion/completions/_tkn

install -d %{buildroot}%{_datadir}/zsh/site-functions
%{buildroot}%{_bindir}/tkn completion zsh > %{buildroot}%{_datadir}/zsh/site-functions/_tkn

install -d %{buildroot}%{_mandir}/man1
cp -a docs/man/man1/* %{buildroot}%{_mandir}/man1

install -d %{buildroot}%{_datadir}/%{name}-redistributable
install -p -m 755 bin/tkn-linux-amd64 %{buildroot}%{_datadir}/%{name}-redistributable/tkn-linux-amd64
install -p -m 755 bin/tkn-darwin-amd64 %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-darwin-amd64
install -p -m 755 bin/tkn-windows-amd64 %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-windows-amd64.exe
cd ..
# tkn-pac
cd %{source_dir_pac}
install -D -m 0755 bin/tkn-pac-linux-amd64 %{buildroot}%{_bindir}/tkn-pac
install -p -m 755 bin/tkn-pac-linux-amd64 %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-pac-linux-amd64
install -p -m 755 bin/tkn-pac-darwin-amd64 %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-pac-darwin-amd64
install -p -m 755 bin/tkn-pac-windows-amd64 %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-pac-windows-amd64.exe
cd ..
cd %{source_dir}
%endif

%ifarch aarch64
install -D -m 0755 bin/tkn-linux-arm64 %{buildroot}%{_bindir}/tkn
install -d %{buildroot}%{_datadir}/bash-completion/completions
%{buildroot}%{_bindir}/tkn completion bash > %{buildroot}%{_datadir}/bash-completion/completions/_tkn

install -d %{buildroot}%{_datadir}/zsh/site-functions
%{buildroot}%{_bindir}/tkn completion zsh > %{buildroot}%{_datadir}/zsh/site-functions/_tkn

install -d %{buildroot}%{_mandir}/man1
cp -a docs/man/man1/* %{buildroot}%{_mandir}/man1

install -d %{buildroot}%{_datadir}/%{name}-redistributable
install -p -m 755 bin/tkn-linux-arm64 %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-linux-arm64
install -p -m 755 bin/tkn-darwin-arm64 %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-darwin-arm64
install -p -m 755 bin/tkn-windows-arm64 %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-windows-arm64.exe
cd ..
# tkn-pac
cd %{source_dir_pac}
install -D -m 0755 bin/tkn-pac-linux-arm64 %{buildroot}%{_bindir}/tkn-pac
install -p -m 755 bin/tkn-pac-linux-arm64 %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-pac-linux-arm64
install -p -m 755 bin/tkn-pac-darwin-arm64 %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-pac-darwin-arm64
install -p -m 755 bin/tkn-pac-windows-arm64 %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-pac-windows-arm64.exe
cd ..
cd %{source_dir}
%endif

%ifarch ppc64le
install -D -m 0755 bin/tkn-linux-ppc64le %{buildroot}%{_bindir}/tkn

install -d %{buildroot}%{_datadir}/bash-completion/completions
%{buildroot}%{_bindir}/tkn completion bash > %{buildroot}%{_datadir}/bash-completion/completions/_tkn

install -d %{buildroot}%{_datadir}/zsh/site-functions
%{buildroot}%{_bindir}/tkn completion zsh > %{buildroot}%{_datadir}/zsh/site-functions/_tkn

install -d %{buildroot}%{_mandir}/man1
cp -a docs/man/man1/* %{buildroot}%{_mandir}/man1

install -d %{buildroot}%{_datadir}/%{name}-redistributable
install -p -m 755 bin/tkn-linux-ppc64le %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-linux-ppc64le
cd ..
# tkn-pac
cd %{source_dir_pac}
install -D -m 0755 bin/tkn-pac-linux-ppc64le %{buildroot}%{_bindir}/tkn-pac
install -p -m 755 bin/tkn-pac-linux-ppc64le %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-pac-linux-ppc64le
cd ..
cd %{source_dir}
%endif

%ifarch s390x
install -D -m 0755 bin/tkn-linux-s390x %{buildroot}%{_bindir}/tkn

install -d %{buildroot}%{_datadir}/bash-completion/completions
%{buildroot}%{_bindir}/tkn completion bash > %{buildroot}%{_datadir}/bash-completion/completions/_tkn

install -d %{buildroot}%{_datadir}/zsh/site-functions
%{buildroot}%{_bindir}/tkn completion zsh > %{buildroot}%{_datadir}/zsh/site-functions/_tkn

install -d %{buildroot}%{_mandir}/man1
cp -a docs/man/man1/* %{buildroot}%{_mandir}/man1

install -d %{buildroot}%{_datadir}/%{name}-redistributable
install -p -m 755 bin/tkn-linux-s390x %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-linux-s390x
cd ..
# tkn-pac
cd %{source_dir_pac}
install -D -m 0755 bin/tkn-pac-linux-s390x %{buildroot}%{_bindir}/tkn-pac
install -p -m 755 bin/tkn-pac-linux-s390x %{buildroot}/%{_datadir}/%{name}-redistributable/tkn-pac-linux-s390x
cd ..
cd %{source_dir}
%endif

%files
%doc %{source_dir}/*.md
%license %{source_dir}/LICENSE
%{_bindir}/tkn
%{_bindir}/tkn-pac
%{_datadir}/zsh/site-functions/*
%{_datadir}/bash-completion/completions/*
%{_mandir}/*

%package redistributable
Summary:        %{product_name} CLI binaries for Linux, macOS, Windows, Power and Z.
BuildRequires:  golang >= %{golang_version}

%description redistributable
%{product_name} CLI cross platform binaries for Linux, macOS, Windows, Power and Z.

%ifarch x86_64
%files redistributable
%license %{source_dir}/LICENSE
%{_datadir}/%{name}-redistributable/tkn-linux-amd64
%{_datadir}/%{name}-redistributable/tkn-darwin-amd64
%{_datadir}/%{name}-redistributable/tkn-windows-amd64.exe
%{_datadir}/%{name}-redistributable/tkn-pac-linux-amd64
%{_datadir}/%{name}-redistributable/tkn-pac-darwin-amd64
%{_datadir}/%{name}-redistributable/tkn-pac-windows-amd64.exe
%endif

%ifarch ppc64le
%files redistributable
%license %{source_dir}/LICENSE
%{_datadir}/%{name}-redistributable/tkn-linux-ppc64le
%{_datadir}/%{name}-redistributable/tkn-pac-linux-ppc64le
%endif

%ifarch s390x
%files redistributable
%license %{source_dir}/LICENSE
%{_datadir}/%{name}-redistributable/tkn-linux-s390x
%{_datadir}/%{name}-redistributable/tkn-pac-linux-s390x
%endif

%ifarch aarch64
%files redistributable
%license %{source_dir}/LICENSE
%{_datadir}/%{name}-redistributable/tkn-linux-arm64
%{_datadir}/%{name}-redistributable/tkn-darwin-arm64
%{_datadir}/%{name}-redistributable/tkn-windows-arm64.exe
%{_datadir}/%{name}-redistributable/tkn-pac-linux-arm64
%{_datadir}/%{name}-redistributable/tkn-pac-darwin-arm64
%{_datadir}/%{name}-redistributable/tkn-pac-windows-arm64.exe
%endif

%changelog
* Thu Oct 13 2022 Shubham Minglani <shmingla@redhat.com> v0.24.1
- Bump version to v0.24.1

* Tue May 17 2022 Vincent Demeester <vdemeest@redhat.com> v0.23.1
- Add support for arm64 for Linux, Windows and Darwin

* Tue Feb 22 2022 Vincent Demeester <vdemeest@redhat.com> v0.22.0-1
- Release for v0.21.0

* Thu Oct 7 2021 Piyush Garg <pgarg@redhat.com> v0.21.0-1
- Release for v0.21.0

* Tue Jun 29 2021 Vincent Demeester <vdemeest@redhat.com> v0.19.0-1
- Release for v0.19.0

* Wed Apr 14 2021 Piyush Garg <pgarg@redhat.com> v0.17.2-1
- Release for v0.17.2

* Wed Jan 13 2021 Savita Ashture <sashture@redhat.com> v0.15.0-1
- Fourth tech preview release

* Tue Nov 24 2020 Savita Ashture <sashture@redhat.com> v0.13.1-3
- Third tech preview release for Multi Arch

* Thu Oct 22 2020 Savita Ashture <sashture@redhat.com> v0.13.1-2
- Third tech preview release

* Mon Aug 03 2020 Khurram Baig <kbaig@redhat.com> v0.11.0-3
- Second tech preview release

* Fri May 08 2020 Piyush Garg <pgarg@redhat.com> v0.9.0-2
- First tech preview release
